diff --git a/ompi/mpi/c/sendrecv.c b/ompi/mpi/c/sendrecv.c
index c74fa000a4e..15f9001ad2c 100644
--- a/ompi/mpi/c/sendrecv.c
+++ b/ompi/mpi/c/sendrecv.c
@@ -92,30 +92,27 @@ int MPI_Sendrecv(const void *sendbuf, int sendcount, MPI_Datatype sendtype,
     if (dest != MPI_PROC_NULL) { /* send */
         rc = MCA_PML_CALL(send(sendbuf, sendcount, sendtype, dest,
                                sendtag, MCA_PML_BASE_SEND_STANDARD, comm));
-#if OPAL_ENABLE_FT_MPI
-        if (OPAL_UNLIKELY(MPI_ERR_PROC_FAILED == rc)) {
-            /* If this is a recoverable error (e.g., ULFM error class),
-             * we need to wait for the posted receive to complete so that the
-             * receive buffer doesn't get updated after the completion of the call.
-             * Hence we cannot return immediately, we need to wait on the recv
-             * req first. */
+        if (OPAL_UNLIKELY(MPI_SUCCESS != rc)) {
             rcs = rc;
-        }
-        else /*  else intentionally spills outside ifdef */
+#if OPAL_ENABLE_FT_MPI
+            /* If this is a PROC_FAILED error, we still need to proceed with
+             * the receive, so that we do not propagate errors to the sender in
+             * the case src != dst, and only dst is dead. In this case the 
+             * recv is garanteed to complete (either in error if the source is 
+             * dead, or successfully if the source is live). */
+            if (OPAL_UNLIKELY(MPI_ERR_PROC_FAILED != rc))
+            /* if intentionally spills outside ifdef */
 #endif
-        /*  If the error semantic does not garantee the completion of the wait on
-         *  the recv-req for that error class, we just invoke the errhandler asap
-         *  to avoid hanging. Note that in this case we are returning the recv
-         *  buffer in an undefined state and the application may not recover. */
-        OMPI_ERRHANDLER_CHECK(rc, comm, rc, FUNC_NAME);
+            ompi_request_cancel(req);
+        }
     }
 
     if (source != MPI_PROC_NULL) { /* wait for recv */
         rc = ompi_request_wait(&req, status);
 #if OPAL_ENABLE_FT_MPI
         /* Sendrecv never returns ERR_PROC_FAILED_PENDING because it is
-         * blocking. Lets complete now that irecv and promote the error
-         * to ERR_PROC_FAILED */
+         * blocking. Lets cancel that irecv to complete it NOW and promote
+         * the error to ERR_PROC_FAILED */
         if( OPAL_UNLIKELY(MPI_ERR_PROC_FAILED_PENDING == rc) ) {
             ompi_request_cancel(req);
             ompi_request_wait(&req, MPI_STATUS_IGNORE);
@@ -128,11 +125,9 @@ int MPI_Sendrecv(const void *sendbuf, int sendcount, MPI_Datatype sendtype,
         }
         rc = MPI_SUCCESS;
     }
-#if OPAL_ENABLE_FT_MPI
     if( OPAL_UNLIKELY(MPI_SUCCESS != rcs && MPI_SUCCESS == rc) ) {
         rc = rcs;
     }
-#endif
 
     OMPI_ERRHANDLER_RETURN(rc, comm, rc, FUNC_NAME);
 }
